#ifndef _KERNEL_INCREMENT_H_
#define _KERNEL_INCREMENT_H_

#include <stdio.h>

__global__ void pingpong_kernel(int* data)
{
    unsigned int counter = 0;
    while(data[threadIdx.x] != 1 && counter != 40000000){++counter;}
    data[threadIdx.x] = counter;
}

__global__ void kernel(float* g_data)
{
	const unsigned int tid = threadIdx.x;
	float data = g_data[tid];

	data += 1;

	g_data[tid] = data;	
}


__global__ void matMul_kernel(float* a, float* b, float* c, int wa, int ha, int wb, int hb)
{
	unsigned int bidx = blockIdx.x;
	//unsigned int bidy = blockIdx.y;
	unsigned int tidx = threadIdx.x;
	//unsigned int tidy = threadIdy.y;
	unsigned int offseta = bidx * wa;	
	unsigned int i = 0;
	float val = 0.0f;
		
#if DEBUG	
	printf("\nbidx: %d, ", bidx);
	printf("tidx: %d, ", tidx);
	printf("offseta: %d, ", offseta);			
#endif
	
	//Sum row i and column j	
	for(i = 0; i < wa; i++)
	{
		val += a[offseta + i] * b[wb * i + tidx];
#if DEBUG
		printf("Index a: %d ", offseta + i);
		printf("Index b: %d ", wb * i + tidx);
		printf("Value: %f\n", val);
#endif 
	}			
	c[offseta + tidx] = val; 
}

#endif 
