#include <iostream>
#include <stdio.h>
//#include <cuda_runtime.h>

#define N 100
#define ROWS 10
#define COLS 10
//#define DEBUG 0

extern "C" void run_test(float* data, int len);
extern "C" void run_matMul(float* h_a, float* h_b, float* h_c, int wa, int ha, int wb, int hb);
extern "C" float run_pingpong(int* data, int numElements, int timeToRunInMs);

void matMulTest();
void pingpongtest(int numElements, int timeToRunInMs);

int main(int argc, char** argv)
{
    int numElem = 32;
    int seconds = 10;    
    if(argc == 3)
    {
        numElem = atoi(argv[1]);
        seconds = atoi(argv[2]);        
    }
    
    printf("PingPong %d elements for %d seconds\n", numElem, seconds);
    pingpongtest(numElem, seconds*1000);

    return 0;
}

void matMulTest()
{
    float a[N];
	float b[N];
	float c[N];
		
	for(int i = 0; i < N; ++i)
	{
		a[i] = 1.0f;
		b[i] = 2.0f;
		c[i] = 0.0f;	
	}
	
	//Run matrix mult on device
	run_matMul(a, b, c, COLS, ROWS, COLS, ROWS);
	
	//Print results
	printf("GPU CALC:\n");	
	for(int i = 0; i < ROWS; ++i)
	{
		for(int j = 0; j < COLS; ++j)
		{
			printf("%f\t", c[i*COLS+j]);	
		}	
		printf("\n");
	}
	
	//Calculate on CPU and print results
	printf("CPU CALC:\n");	
	for(int i = 0; i < ROWS; ++i)
	{
		for(int j = 0; j < COLS; ++j)
		{
			float val = 0.0f;
			for(int k = 0; k < COLS; ++k)
			{
				val += a[i*COLS+k] * b[k*ROWS+j];
			}
			c[i*COLS+j] = val;
		}	
	}
	
	for(int i = 0; i < ROWS; i++)
	{
		for(int j = 0; j < COLS; j++)
		{
			printf("%f\t", c[i*COLS+j]);	
		}	
		printf("\n");
	}
}

void pingpongtest(int numElements, int timeToRunInMs)
{    
    int data[numElements];
    float iterPrSec = 0.0f;
    int value = numElements * timeToRunInMs;
    
    //Run pingpong on device
    printf("Running pingpong test\n");
    iterPrSec = run_pingpong(data, numElements, timeToRunInMs);

    
    printf("Value in: %d\n", value);
    
        
    if(numElements <= 256)
    {        
        printf("Values out:\n");
        for(int i = 0; i < numElements; ++i)
        {        
            if(i%10 == 0 && i != 0)
                printf("\n");
            printf("%d\t", data[i]);
        }
    }
    printf("\nIterations pr. second: %.2f\n", iterPrSec);
}
